package org.apache.samoa.moa.core;

/*
 * #%L
 * SAMOA
 * %%
 * Copyright (C) 2014 - 2015 Apache Software Foundation
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import java.io.Serializable;

import org.apache.samoa.instances.Instance;

public class InstanceExample implements Example<Instance>, Serializable {

  public Instance instance;

  public InstanceExample(Instance inst)
  {
    this.instance = inst;
  }

  @Override
  public Instance getData() {
    return this.instance;
  }

  @Override
  public double weight() {
    return this.instance.weight();
  }

  @Override
  public void setWeight(double w) {
    this.instance.setWeight(w);
  }

}
